#include "mp3.hpp"
#include "../osHandles.h"
#include "../fat/ff.h"				// FAT File System Library
#include "../fat/diskio.h" 			// Disk IO Initialize SPI Mutex
#include "drivers/sta013.h"
#include "drivers/ssp_spi.h"
#include "utils/rprintf.h"
#include <stdlib.h>                 // atoi()
#include <stdio.h>                  // printf() or iprintf()
#include <string.h>                 // strtok()

void mp3Task(void* p)
{
	OSHANDLES *osHandles = (OSHANDLES*) p;
	for (;;)
	{
		// TODO 4.  Perform xQueueReceive from "song name" queue
		char FileNameSong[16];
		if (xQueueReceive(osHandles->queue.song,FileNameSong,1000))
		{
			// TODO 5.  Try to open the file, and read a block from file
		    FIL file;
			if (FR_OK == f_open(&file, FileNameSong, (FA_READ
					| FA_OPEN_EXISTING)))
			{
				rprintf("File %s successfully opened\n", FileNameSong);
				char buff[513] = { 0 };

				const unsigned int bytesToRead = 512;
				unsigned int bytesRead = 0;
				rprintf("Playing mp3...\n");
				do
				{
					if (FR_OK != f_read(&file, buff, bytesToRead, &bytesRead))
					{
						rprintf( "--Failed to read file after having it opened--\n");
						break;
					}
					//lock spi
					if (pdPASS != xSemaphoreTake(osHandles->lock.SPI,1000))
					{
						rprintf("SPI resource not available...\n");
						break;
					}
					//assert mp3 cs
					SELECT_MP3_CS();
					//					rprintf("    %s", buff);
					int i = 0;
					while (i < bytesRead)
					{
						if (STA013_NEEDS_DATA())
						{
							rxTxByteSSPSPI(buff[i++]);
						}
						else
						{
							vTaskDelay(3);
						}
					}
					//deassert
					DESELECT_MP3_CS();
					//release spi
					xSemaphoreGive(osHandles->lock.SPI);
					// To Stop Current Song
					if(uxQueueMessagesWaiting(osHandles->queue.song)>0)
					{
						break;
					}
					// For Fast Forward
					if(uxQueueMessagesWaiting(osHandles->queue.SongBreak)>0)
					{
					char AnotherNameSong[16];
					if (xQueueReceive(osHandles->queue.SongBreak,AnotherNameSong,1000))
								{
					 if (FR_OK == f_lseek(&file, f_tell(&file)+(1024*100)))
							continue;
						    }
					}

				} while (bytesRead == bytesToRead);

				f_close(&file);
				rprintf("File closed...\n");

			}

			if (FR_OK != f_open(&file, FileNameSong, (FA_READ
					| FA_OPEN_EXISTING)))
			{
				rprintf("FILENAME: %s is invalid! Please try again..",
						FileNameSong);
			}

		}
		//
	}
}
